class HangmanGenerator:
    
    def __init__(self, letters, minlen, maxlen):
        self.letters = [letter for letter in letters]
        self.minlen = minlen
        self.maxlen = maxlen
        self.possWords = []
    
    # can make it prioritize uncommon characters, no repetitions, long words
    def findWords(self):
        f = open('words.txt', 'r')
        line = f.readline()
        while (line != ''):
            word = line.split()[0].lower()
            if len(word) > self.maxlen:
                break
            elif len(word) >= self.minlen:
                available = self.letters[:]
                for letter in word:
                    if letter in available:
                        available.remove(letter)
                    else:
                        break
                if len(available) == len(self.letters) - len(word):
                    self.possWords.append(word)
            line = f.readline()
        f.close()
        self.possWords.reverse()
        return self.possWords

puzzle = raw_input('Enter the available letters: ')
hangen = HangmanGenerator(puzzle, 4, 8)
words = hangen.findWords()
if len(words) > 0:
    for word in words:
        print word
else:
    print 'No possible words.'